commit dca8e28c990547648543175de9b6e05356f77e8a
Author: Harald Anlauf <anlauf@gmx.de>
Date:   Fri Mar 17 22:24:49 2023 +0100

    Fortran: procedures with BIND(C) attribute require explicit interface [PR85877]
    
    gcc/fortran/ChangeLog:
    
            PR fortran/85877
            * resolve.c (resolve_fl_procedure): Check for an explicit interface
            of procedures with the BIND(C) attribute (F2018:15.4.2.2).
    
    gcc/testsuite/ChangeLog:
    
            PR fortran/85877
            * gfortran.dg/pr85877.f90: New test.
    
    (cherry picked from commit 5426ab34643d9e6502f3ee572891a03471fa33ed)

diff --git a/gcc/fortran/resolve.c b/gcc/fortran/resolve.c
index 98e94044e02..dc127abeb64 100644
--- a/gcc/fortran/resolve.c
+++ b/gcc/fortran/resolve.c
@@ -13413,6 +13413,16 @@ check_formal:
 	    }
 	}
     }
+
+  /* F2018:15.4.2.2 requires an explicit interface for procedures with the
+     BIND(C) attribute.  */
+  if (sym->attr.is_bind_c && sym->attr.if_source == IFSRC_UNKNOWN)
+    {
+      gfc_error ("Interface of %qs at %L must be explicit",
+		 sym->name, &sym->declared_at);
+      return false;
+    }
+
   return true;
 }
 
diff --git a/gcc/testsuite/gfortran.dg/pr85877.f90 b/gcc/testsuite/gfortran.dg/pr85877.f90
new file mode 100644
index 00000000000..d8f08cbd210
--- /dev/null
+++ b/gcc/testsuite/gfortran.dg/pr85877.f90
@@ -0,0 +1,25 @@
+! { dg-do compile }
+! PR fortran/85877
+! A procedure with the bind(c) attribute shall have an explicit interface
+! Contributed by G. Steinmetz
+
+function f() bind(c)
+  f = 42.
+end
+
+subroutine p
+  bind(c) f     ! { dg-error "must be explicit" }
+  x = f()
+end
+
+function g() bind(c)
+  g = 42.
+end
+
+subroutine s
+  interface
+     function g() bind(c)
+     end function g
+  end interface
+  x = g()
+end

